/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.KategoryPegawaiDao;
import com.portofolio.dto.KategoryPegawaiDto;
import com.portofolio.entity.KategoryPegawai;
import com.portofolio.entity.vo.KategoryPegawaiId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class KategoryPegawaiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private KategoryPegawaiDao kategoryPegawaiDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(KategoryPegawaiDto kategoryPegawaiDto) {
		result.clear();
		KategoryPegawaiId id = new KategoryPegawaiId();
		String kdKategoryPegawai =getIdTerahir(KategoryPegawai.class.getSimpleName(), 2);
		id.setKdKategoryPegawai(kdKategoryPegawai);
		id.setKdProfile(getKdProfile());
		KategoryPegawai kategoryPegawai = CommonUtil.findOne(kategoryPegawaiDao, id);
		if (CommonUtil.isNullOrEmpty(kategoryPegawai)) {
			kategoryPegawai = new KategoryPegawai();
			BeanUtils.copyProperties(kategoryPegawaiDto, kategoryPegawai);
			kategoryPegawai.setNoRec(generateUuid32());
			kategoryPegawai.setVersion(1);
			kategoryPegawai.setId(id);
			kategoryPegawai = kategoryPegawaiDao.save(kategoryPegawai);
			result.put("kategoryPegawai", kategoryPegawai);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("kategoryPegawai.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(KategoryPegawaiDto kategoryPegawaiDto, String kdKategoryPegawai, Integer version) {
		result.clear();
		KategoryPegawaiId id = new KategoryPegawaiId();
		id.setKdKategoryPegawai(kdKategoryPegawai);
		id.setKdProfile(getKdProfile());
		KategoryPegawai kategoryPegawai = CommonUtil.findOne(kategoryPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(kategoryPegawai)) {
			if (version < kategoryPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(kategoryPegawaiDto, kategoryPegawai);
			kategoryPegawai.setVersion(version);
			kategoryPegawai = kategoryPegawaiDao.save(kategoryPegawai);
			result.put("kategoryPegawai", kategoryPegawai);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaKategoryPegawai,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaKategoryPegawai)) {
			pageRes = kategoryPegawaiDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = kategoryPegawaiDao.findAllList(getKdProfile(), namaKategoryPegawai, statusEnabled, pageReq);
		}
		result.put("kategoryPegawai", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdKategoryPegawai(String kdKategoryPegawai) {
		result.clear();
		result.put("kategoryPegawai", kategoryPegawaiDao.findByKdKategoryPegawai(getKdProfile(), kdKategoryPegawai, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(String kdKategoryPegawai, Integer version) {
		result.clear();
		KategoryPegawaiId id = new KategoryPegawaiId();
		id.setKdKategoryPegawai(kdKategoryPegawai);
		id.setKdProfile(getKdProfile());
		KategoryPegawai kategoryPegawai = CommonUtil.findOne(kategoryPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(kategoryPegawai)) {
			if (version < kategoryPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			kategoryPegawai.setStatusEnabled(false);
			kategoryPegawai.setVersion(version);
			kategoryPegawai = kategoryPegawaiDao.save(kategoryPegawai);
			result.put("kategoryPegawai", kategoryPegawai);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
